apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ crtmgr_name }}
  name: {{ crtmgr_name }}
  namespace: {{ namespace }}
spec:
  replicas: 1
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ crtmgr_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ crtmgr_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ crtmgr_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
      containers:
      - args:
        - --secrets-annotation-selector=cert-manager.io/certificate-name
        - --secrets-include-glob=*.crt
        - --logtostderr
        command:
        - ./app
        env:
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='certmanagerexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='certmanagerexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          tcpSocket:
            port: 8080
          initialDelaySeconds: 5
          timeoutSeconds: 2
        name: cert-exporter
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /metrics
            port: 8080
          initialDelaySeconds: 5
          timeoutSeconds: 4
        resources:
          limits:
            cpu: "{{ certmanagerexporter_cpu_limit }}"
            memory: "{{ certmanagerexporter_memory_limit }}"
          requests:
            cpu: "{{ certmanagerexporter_cpu_request }}"
            memory: "{{ certmanagerexporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
      serviceAccountName: {{ crtmgr_name }}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='certmanagerexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - cert-exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='certmanagerexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
